package uam.patrones.arreglame.clases;

public class Builder {

	private String titulo;
	private String isbn;
	private float precio;
	
	private Editorial editorial;
	private Autor autor;
	
	
	public Builder titulo(String titulo) {
		this.titulo = titulo;
		return this;
	}
	
	public Builder isbn(String isbn) {
		this.isbn = isbn;
		return this;
	}
	
	public Builder precio(float precio) {
		this.precio = precio;
		return this;
	}
	
	public Builder editorial (String clave, String nombre) {
		this.editorial = new Editorial(clave, nombre);
		return this;
	}
	
	public Builder autor(String rfc, String nombre) {
		this.autor = new Autor(rfc, nombre);
		return this;
	}
	
	public Libro libro(Builder builder) {
		Libro libro = new Libro();
		libro.setTitulo(builder.titulo);
		libro.setIsbn(builder.isbn);
		libro.setPrecio(builder.precio);
		libro.setAutor(builder.autor);
		libro.setEditorial(builder.editorial);
		
		return libro;
		
	}
	
}
